Properties Methods Events Config Options Direct Link

    Observable
      Connection
        Ajax

# Class Ext.Ajax

Package: | Ext
Defined In: | Connection.js
Class: | Ajax
Extends: | Connection

Global Ajax request class. Provides a simple way to make Ajax requests with maximum flexibility. Example usage:

    // Basic request
    Ext.Ajax.request({
       url: 'foo.php',
       success: someFn,
       failure: otherFn,
       headers: {
           'my-header': 'foo'
       },
       params: { foo: 'bar' }
    });

    // Simple ajax form submission
    Ext.Ajax.request({
        form: 'some-form',
        params: 'foo=bar'
    });

    // Default headers to pass in every request
    Ext.Ajax.defaultHeaders = {
        'Powered-By': 'Ext'
    };

    // Global Ajax events can be handled on every request!
    Ext.Ajax.on('beforerequest', this.showSpinner, this);

This class is a singleton and cannot be created directly.

## Config Options

Config Options | Defined By
--- | ---
| listeners : Object A config object containing one or more event handlers to be added to this object during initialization. This should b... A config object containing one or more event handlers to be added to this object during initialization. This should be a valid listeners config object as specified in the addListener example for attaching multiple handlers at once. | Observable

## Public Properties

Property | Defined By
--- | ---
| autoAbort : Boolean Whether a new request should abort any pending requests. (defaults to false) | Ajax
| defaultHeaders : Object An object containing request headers which are added to each request made by this object. (defaults to undefined) | Ajax
| disableCaching : Boolean True to add a unique cache-buster param to GET requests. (defaults to true) | Ajax
| extraParams : Object An object containing properties which are used as extra parameters to each request made by this object. (defaults to... An object containing properties which are used as extra parameters to each request made by this object. (defaults to undefined) | Ajax
| method : String The default HTTP method to be used for requests. (defaults to undefined; if not set but parms are present will use P... The default HTTP method to be used for requests. (defaults to undefined; if not set but parms are present will use POST, otherwise GET) | Ajax
| timeout : Number The timeout in milliseconds to be used for requests. (defaults to 30000) | Ajax
| url : String The default URL to be used for requests to the server. (defaults to undefined) | Ajax

## Public Methods

Method | Defined By
--- | ---

abort( [`Number transactionId`] ) : void
Aborts any outstanding request.
Aborts any outstanding request.
Parameters:

- `transactionId` : Number
  (Optional) defaults to the last transaction

Returns:

- `void`

Connection

addEvents( `Object object` ) : void
Used to define events on this Observable
Used to define events on this Observable
Parameters:

- `object` : Object
  The object with the events defined

Returns:

- `void`

Observable

addListener( `String eventName`, `Function handler`, [`Object scope`], [`Object options`] ) : void
Appends an event handler to this component
Appends an event handler to this component
Parameters:

- `eventName` : String
  The type of event to listen for
- `handler` : Function
  The method the event invokes
- `scope` : Object
  (optional) The scope in which to execute the handler function. The handler function's "this" context.
- `options` : Object
  (optional) An object containing handler configuration properties. This may contain any of the following properties:
  - scope : Object

    The scope in which to execute the handler function. The handler function's "this" context.

  - delay : Number

    The number of milliseconds to delay the invocation of the handler after the event fires.

  - single : Boolean

    True to add a handler to handle just the next firing of the event, and then remove itself.

  - buffer {Number} Causes the handler to be scheduled to run in an Ext.util.DelayedTask delayed by the specified number of milliseconds. If the event fires again within that time, the original handler is not invoked, but the new handler is scheduled in its place.

  Combining Options
  Using the options argument, it is possible to combine different types of listeners:
  A normalized, delayed, one-time listener that auto stops the event and passes a custom argument (forumId)

      el.on('click', this.onClick, this, {
          single: true,
          delay: 100,
          forumId: 4
      });

  Attaching multiple handlers in 1 call
  The method also allows for a single argument to be passed which is a config object containing properties which specify multiple handlers.

      foo.on({
          'click' : {
              fn: this.onClick,
              scope: this,
              delay: 100
          },
          'mouseover' : {
              fn: this.onMouseOver,
              scope: this
          },
          'mouseout' : {
              fn: this.onMouseOut,
              scope: this
          }
      });

  Or a shorthand syntax:

      foo.on({
          'click' : this.onClick,
          'mouseover' : this.onMouseOver,
          'mouseout' : this.onMouseOut,
           scope: this
      });

Returns:

- `void`

Observable

fireEvent( `String eventName`, `Object... args` ) : Boolean
Fires the specified event with the passed parameters (minus the event name).
Fires the specified event with the passed parameters (minus the event name).
Parameters:

- `eventName` : String
- `args` : Object...
  Variable number of parameters are passed to handlers

Returns:

- `Boolean`
  returns false if any of the handlers return false otherwise it returns true

Observable

hasListener( `String eventName` ) : Boolean
Checks to see if this object has any listeners for a specified event
Checks to see if this object has any listeners for a specified event
Parameters:

- `eventName` : String
  The name of the event to check for

Returns:

- `Boolean`
  True if the event is being listened for, else false

Observable

isLoading( [`Number transactionId`] ) : Boolean
Determine whether this object has a request outstanding.
Determine whether this object has a request outstanding.
Parameters:

- `transactionId` : Number
  (Optional) defaults to the last transaction

Returns:

- `Boolean`
  True if there is an outstanding request.

Connection

on( `String eventName`, `Function handler`, [`Object scope`], [`Object options`] ) : void
Appends an event handler to this element (shorthand for addListener)
Appends an event handler to this element (shorthand for addListener)
Parameters:

- `eventName` : String
  The type of event to listen for
- `handler` : Function
  The method the event invokes
- `scope` : Object
  (optional) The scope in which to execute the handler function. The handler function's "this" context.
- `options` : Object
  (optional)

Returns:

- `void`

Observable

purgeListeners() : void
Removes all listeners for this object
Removes all listeners for this object
Parameters:

- None.

Returns:

- `void`

Observable

removeListener( `String eventName`, `Function handler`, [`Object scope`] ) : void
Removes a listener
Removes a listener
Parameters:

- `eventName` : String
  The type of event to listen for
- `handler` : Function
  The handler to remove
- `scope` : Object
  (optional) The scope (this object) for the handler

Returns:

- `void`

Observable

request( [`Object options`] ) : Number
Sends an HTTP request to a remote server. Important: Ajax server requests are asynchronous, and this call will return...

Sends an HTTP request to a remote server.

Important: Ajax server requests are asynchronous, and this call will return before the response has been recieved. Process any returned data in a callback function.

Parameters:

- `options` : Object
  An object which may contain the following properties:
  - url : String (Optional)

    The URL to which to send the request. Defaults to configured URL

  - params : Object/String/Function (Optional)

    An object containing properties which are used as parameters to the request, a url encoded string or a function to call to get either.

  - method : String (Optional)

    The HTTP method to use for the request. Defaults to the configured method, or if no method was configured, "GET" if no parameters are being sent, and "POST" if parameters are being sent.

  - callback : Function (Optional)

    The function to be called upon receipt of the HTTP response. The callback is called regardless of success or failure and is passed the following parameters:

    - options : Object

      The parameter to the request call.

    - success : Boolean

      True if the request succeeded.

    - response : Object

      The XMLHttpRequest object containing the response data. See http://www.w3.org/TR/XMLHttpRequest/ for details about accessing elements of the response.

  - success : Function (Optional)

    The function to be called upon success of the request. The callback is passed the following parameters:

    - response : Object

      The XMLHttpRequest object containing the response data.

    - options : Object

      The parameter to the request call.

  - failure : Function (Optional)

    The function to be called upon failure of the request. The callback is passed the following parameters:

    - response : Object

      The XMLHttpRequest object containing the response data.

    - options : Object

      The parameter to the request call.

  - scope : Object (Optional)

    The scope in which to execute the callbacks: The "this" object for the callback function. Defaults to the browser window.

  - form : Object/String (Optional)

    A form object or id to pull parameters from.

  - isUpload : Boolean (Optional)

    True if the form object is a file upload (will usually be automatically detected).

  - headers : Object (Optional)

    Request headers to set for the request.

  - xmlData : Object (Optional)

    XML document to use for the post. Note: This will be used instead of params for the post data. Any params will be appended to the URL.

  - jsonData : Object/String (Optional)

    JSON data to use as the post. Note: This will be used instead of params for the post data. Any params will be appended to the URL.

  - disableCaching : Boolean (Optional)

    True to add a unique cache-buster param to GET requests.

  The options object may also contain any other property which might be needed to perform postprocessing in a callback because it is passed to callback functions.

Returns:

- `Number`
  transactionId The id of the server transaction. This may be used to cancel the request.

Connection

resumeEvents() : void
Resume firing events. (see suspendEvents)
Resume firing events. (see suspendEvents)
Parameters:

- None.

Returns:

- `void`

Observable

serializeForm( `String/HTMLElement form` ) : String
Serialize the passed form into a url encoded string
Serialize the passed form into a url encoded string
Parameters:

- `form` : String/HTMLElement

Returns:

- `String`

Ajax

suspendEvents() : void
Suspend the firing of all events. (see resumeEvents)
Suspend the firing of all events. (see resumeEvents)
Parameters:

- None.

Returns:

- `void`

Observable

un( `String eventName`, `Function handler`, [`Object scope`] ) : void
Removes a listener (shorthand for removeListener)
Removes a listener (shorthand for removeListener)
Parameters:

- `eventName` : String
  The type of event to listen for
- `handler` : Function
  The handler to remove
- `scope` : Object
  (optional) The scope (this object) for the handler

Returns:

- `void`

Observable

## Public Events

Event | Defined By
--- | ---

beforerequest : ( `Connection conn`, `Object options` )
Fires before a network request is made to retrieve a data object.
Fires before a network request is made to retrieve a data object.
Listeners will be called with the following arguments:

- `conn` : Connection
  This Connection object.
- `options` : Object
  The options config object passed to the request method.

Connection

requestcomplete : ( `Connection conn`, `Object response`, `Object options` )
Fires if the request was successfully completed.
Fires if the request was successfully completed.
Listeners will be called with the following arguments:

- `conn` : Connection
  This Connection object.
- `response` : Object
  The XHR object containing the response data. See The XMLHttpRequest Object for details.
- `options` : Object
  The options config object passed to the request method.

Connection

requestexception : ( `Connection conn`, `Object response`, `Object options` )
Fires if an error HTTP status was returned from the server. See HTTP Status Code Definitions for details of HTTP stat...
Fires if an error HTTP status was returned from the server. See HTTP Status Code Definitions for details of HTTP status codes.
Listeners will be called with the following arguments:

- `conn` : Connection
  This Connection object.
- `response` : Object
  The XHR object containing the response data. See The XMLHttpRequest Object for details.
- `options` : Object
  The options config object passed to the request method.

Connection